test: UST tracing destroy flush behavior with tracefile rotation
authorMathieu Desnoyers <mathieu.desnoyers@efficios.com>
Wed, 18 May 2016 18:04:19 +0000 (14:04 -0400)
committerJérémie Galarneau <jeremie.galarneau@efficios.com>
Thu, 19 May 2016 04:44:12 +0000 (00:44 -0400)
Signed-off-by: Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
configure.ac
tests/fast_regression
tests/regression/ust/Makefile.am
tests/regression/ust/rotation-destroy-flush/Makefile.am [new file with mode: 0644]
tests/regression/ust/rotation-destroy-flush/test_rotation_destroy_flush [new file with mode: 0755]

index 4f2189b443b76ca80e4e6ff18fc3b8df88063d55..ddb294b218ba09c1b11ae17d2112b646da06e279 100644 (file)
@@ -1002,6 +1002,7 @@ AC_CONFIG_FILES([
        tests/regression/ust/getcpu-override/Makefile
        tests/regression/ust/clock-override/Makefile
        tests/regression/ust/type-declarations/Makefile
+       tests/regression/ust/rotation-destroy-flush/Makefile
        tests/stress/Makefile
        tests/unit/Makefile
        tests/unit/ini_config/Makefile
index aa0c0433633819d8561948651f199ba924388ccd..0c4f07925865724290cfc409d89026d9dc3813c0 100644 (file)
@@ -27,5 +27,6 @@ regression/ust/java-log4j/test_java_log4j
 regression/ust/python-logging/test_python_logging
 regression/ust/getcpu-override/test_getcpu_override
 regression/ust/clock-override/test_clock_override
+regression/ust/rotation-destroy-flush/test_rotation_destroy_flush
 regression/ust/test_event_basic
 regression/ust/test_event_tracef
index 1b87cc9dddac8c553ac1b73804cf95a88cf476b7..76862514b8112ecb8d7517cb80ffd0383ad0bb8f 100644 (file)
@@ -2,7 +2,8 @@ if HAVE_LIBLTTNG_UST_CTL
 SUBDIRS = nprocesses high-throughput low-throughput before-after multi-session \
                overlap buffers-pid linking daemon exit-fast fork libc-wrapper \
                periodical-metadata-flush java-jul java-log4j python-logging \
-               getcpu-override clock-override type-declarations
+               getcpu-override clock-override type-declarations \
+               rotation-destroy-flush
 
 if HAVE_OBJCOPY
 SUBDIRS += baddr-statedump ust-dl
diff --git a/tests/regression/ust/rotation-destroy-flush/Makefile.am b/tests/regression/ust/rotation-destroy-flush/Makefile.am
new file mode 100644 (file)
index 0000000..14b869e
--- /dev/null
@@ -0,0 +1,16 @@
+noinst_SCRIPTS = test_rotation_destroy_flush
+EXTRA_DIST = test_rotation_destroy_flush
+
+all-local:
+       @if [ x"$(srcdir)" != x"$(builddir)" ]; then \
+               for script in $(EXTRA_DIST); do \
+                       cp -f $(srcdir)/$$script $(builddir); \
+               done; \
+       fi
+
+clean-local:
+       @if [ x"$(srcdir)" != x"$(builddir)" ]; then \
+               for script in $(EXTRA_DIST); do \
+                       rm -f $(builddir)/$$script; \
+               done; \
+       fi
diff --git a/tests/regression/ust/rotation-destroy-flush/test_rotation_destroy_flush b/tests/regression/ust/rotation-destroy-flush/test_rotation_destroy_flush
new file mode 100755 (executable)
index 0000000..a7a9377
--- /dev/null
@@ -0,0 +1,150 @@
+#!/bin/bash
+#
+# Copyright (C) - 2015 Jonathan Rajotte <jonathan.rajotte-julien@efficios.com>
+# Copyright (C) - 2016 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+#
+# This library is free software; you can redistribute it and/or modify it under
+# the terms of the GNU Lesser General Public License as published by the Free
+# Software Foundation; version 2.1 of the License.
+#
+# This library is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+# details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with this library; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+TEST_DESC="UST - Rotation destroy flush"
+
+CURDIR=$(dirname $0)/
+TESTDIR=$CURDIR/../../..
+SESSION_NAME="rotation_destroy_flush"
+
+TESTAPP_PATH="$TESTDIR/utils/testapp"
+TESTAPP_NAME="gen-ust-events"
+TESTAPP_BIN="$TESTAPP_PATH/$TESTAPP_NAME/$TESTAPP_NAME"
+NUM_EVENT=1000000
+EVENT_NAME="tp:tptest"
+CHANNEL_NAME="testchan"
+PAGE_SIZE=$(getconf PAGE_SIZE)
+SIZE_LIMIT=$PAGE_SIZE
+
+NR_ITER=10
+NUM_TESTS=$((15*$NR_ITER))
+
+# Ensure the daemons invoke abort on error.
+export LTTNG_ABORT_ON_ERROR=1
+
+source $TESTDIR/utils/utils.sh
+
+# MUST set TESTDIR before calling those functions
+function run_app()
+{
+       $TESTAPP_BIN $NUM_EVENT
+       ok $? "Application done"
+}
+
+function signal_cleanup()
+{
+       diag "*** Exiting ***"
+       stop_lttng_sessiond
+       exit 1
+}
+
+function enable_ust_lttng_channel_size_limit ()
+{
+       sess_name="$1"
+       channel_name="$2"
+       tracefile_size_limit="$3"
+
+       test_name="Enable channel $channel_name "
+       test_name+="for session $sess_name: "
+       test_name+="$tracefile_size_limit bytes tracefile limit"
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel \
+           -u $channel_name -s $sess_name --buffers-pid \
+           -C $tracefile_size_limit >/dev/null 2>&1
+
+       ok $? "$test_name"
+}
+
+function enable_ust_lttng_event_per_channel ()
+{
+       sess_name="$1"
+       event_name="$2"
+       channel_name="$3"
+
+       test_name="Enable event $event_name "
+       test_name+="for session $sess_name "
+       test_name+="in channel $channel_name"
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-event "$event_name" \
+           -s $sess_name -u -c $channel_name >/dev/null 2>&1
+
+       ok $? "$test_name"
+}
+
+function test_rotation_destroy_flush_single()
+{
+       start_lttng_sessiond
+
+       create_lttng_session_ok $SESSION_NAME $TRACE_PATH
+       enable_ust_lttng_channel_size_limit \
+               $SESSION_NAME $CHANNEL_NAME $SIZE_LIMIT
+       enable_ust_lttng_event_per_channel \
+               $SESSION_NAME $EVENT_NAME $CHANNEL_NAME
+       start_lttng_tracing_ok $SESSION_NAME
+       run_app
+       # stop and destroy
+       stop_lttng_tracing_ok $SESSION_NAME
+       destroy_lttng_session_ok $SESSION_NAME
+
+       rm -rf $TRACE_PATH
+
+       create_lttng_session_ok $SESSION_NAME $TRACE_PATH
+       enable_ust_lttng_channel_size_limit \
+               $SESSION_NAME $CHANNEL_NAME $SIZE_LIMIT
+       enable_ust_lttng_event_per_channel \
+               $SESSION_NAME $EVENT_NAME $CHANNEL_NAME
+       start_lttng_tracing_ok $SESSION_NAME
+       run_app
+       # destroy only
+       destroy_lttng_session_ok $SESSION_NAME
+
+       rm -rf $TRACE_PATH
+
+       stop_lttng_sessiond
+}
+
+function test_rotation_destroy_flush()
+{
+       for a in $(seq 1 ${NR_ITER}); do
+               diag "Iteration ${a}/${NR_ITER}"
+               test_rotation_destroy_flush_single
+       done
+}
+
+
+plan_tests $NUM_TESTS
+
+print_test_banner "$TEST_DESC"
+
+TESTS=(
+       "test_rotation_destroy_flush"
+)
+
+TEST_COUNT=${#TESTS[@]}
+i=0
+
+while [ "$i" -lt "$TEST_COUNT" ]; do
+
+       trap signal_cleanup SIGTERM SIGINT
+
+       TRACE_PATH=$(mktemp -d)
+
+       # Execute test
+       ${TESTS[$i]}
+
+       let "i++"
+done
This page took 0.039682 seconds and 4 git commands to generate.